function  clear_elar_gray(varargin)
[name,area, n_erode_hor, n_reconst_hor, n_reconst_ver,n_kind_fill, n_filterwindowsize ,gamma, save_pictures] = parseInputs(varargin{:});



file_name  = [name ,'.tif'];
IM = imread( file_name);

if(area(1) > 0 && area(2) > 0 && area(3) > 0  && area(4) > 0)
    
    IM1=imcrop(IM,area);
else
    IM1=IM;
end 





m = size(IM1,1);
n = size(IM1,2);
S_ROW = sum( IM1')/ n; % row
S_IM = (sum( S_ROW) / m);   


if( S_IM > 100)
	IM2 = 255 - IM1;
	%figure('Name', 'SOURCE PICTURE1'), imshow(uint8(IM));
else
	IM2 = IM1;
	%figure('Name', 'SOURCE PICTURE'), imshow(uint8(255-IM1));
end
f_obr=imreconstruct(imerode(IM2,ones(1,71)),IM2);
f=imsubtract(IM2,f_obr);
f_image=[name,'_f.tif'];
imwrite(f,f_image);


%     f2=im2double(f);
%     h=fspecial('gaussian',n_filterwindowsize,gamma);
%     fd=imfilter(f2,h,'replicate');
  

%if(save_pictures)
 %   fd_image=[name,'_fd.tif'];
 %   imwrite(fd,fd_image);
%end
fd=f;

f_obr=imreconstruct(imerode(fd,ones(1,n_erode_hor)),fd);

if(save_pictures)
    f_obr_image=[name,'_f_obr.tif'];
    imwrite(f_obr,f_obr_image);
end

g_obrd=imdilate(f_obr,ones(1,n_reconst_hor));

if(save_pictures)
    g_obrd_image=[name,'_g_obrd.tif'];
    imwrite(g_obrd,g_obrd_image);
end;

g_obrd2=imdilate(g_obrd,ones(n_reconst_ver,1));

if(save_pictures)
    g_obrd2_image=[name,'_g_obrd2.tif'];
    imwrite(g_obrd2,g_obrd2_image);
end;
f3=uint8(f);
f2=imreconstruct(min(g_obrd2,f3),f3);

if(save_pictures)
    f2_image=[name,'_f2.tif'];
    imwrite(f2,f2_image);
end

final=255-f2;

final_image=[name,'_final.tif'];
imwrite(final,final_image,'Resolution',[300 300]);

function [name, area, n_erode_hor, n_reconst_hor, n_reconst_ver,n_kind_fill, n_filterwindowsize ,gamma, save_pictures] = parseInputs(varargin)


iptchecknargin(1,9,nargin,mfilename);


name = varargin{1};
area = varargin{2};
%n_erode_hor=10;
%n_reconst_hor=45;
%n_reconst_ver=1;
%n_kind_fill=2;
%n_filterwindowsize=10;
%gamma=15;


n_erode_hor=5;
if nargin > 2
  n_erode_hor = varargin{3};
  iptcheckinput(n_erode_hor, {'double'}, {}, mfilename, 'n_erode_hor', 3);

end

n_reconst_hor=20;
if nargin > 3
  n_reconst_hor = varargin{4};
  iptcheckinput(n_reconst_hor, {'double'}, {}, mfilename, 'n_reconst_hor', 4);

end

n_reconst_ver=15;
if nargin > 4
  n_reconst_ver = varargin{5};
  iptcheckinput(n_reconst_ver, {'double'}, {}, mfilename, 'n_reconst_ver', 5);

end

n_kind_fill=1;
if nargin > 5
  n_kind_fill = varargin{6};
  iptcheckinput(n_kind_fill, {'double'}, {}, mfilename, 'n_kind_fill', 6);

end

n_filterwindowsize=12;
if nargin > 6
  n_filterwindowsize = varargin{7};
  iptcheckinput(n_filterwindowsize, {'double'}, {}, mfilename, 'n_filterwindowsize', 7);

end

gamma=15;
if nargin > 7
  gamma = varargin{8};
  iptcheckinput(gamma, {'double'}, {}, mfilename, 'gamma', 8);

end

save_pictures=1;

if nargin > 8
  save_pictures = varargin{9};
  iptcheckinput(save_pictures, {'logical'}, {}, mfilename, 'save_pictures', 9);

end





%-------------------------------
function displayInternalError(string)

eid = sprintf('Images:%s:internalError',mfilename);
msg = sprintf('Internal error: %s is not valid.',upper(string));
error(eid,'%s',msg);






