function  clear_image_elar(varargin)
[name, n_erode_hor, n_reconst_hor, n_reconst_ver,n_kind_fill, n_filterwindowsize ,gamma, save_pictures] = parseInputs(varargin{:});
%name='test7';
%n_erode_hor=10;
%n_reconst_hor=45;
%n_reconst_ver=1;
%n_kind_fill=1;
%n_filterwindowsize=10;
%gamma=15;

initial_image=[name,'.tif'];

f1=imread(initial_image);
if (islogical(f1) ~= 1)
    
    BW = im2bw(f1, graythresh(f1));
    f =~BW;
end

if (islogical(f1) == 1)
    f=~f1;
end


if(save_pictures)
    f_image=[name,'_f.tif'];
    imwrite(f,f_image,'Resolution',[300 300]);
end

if  (n_kind_fill==0)
    fd=f;
end 
if  (n_kind_fill ==1)

     f2=im2double(f);
     h=fspecial('gaussian',n_filterwindowsize,gamma);
     fd=imfilter(f2,h,'replicate');
     fd=im2bw(fd, 1.5*graythresh(fd));
end
if  (n_kind_fill ==2)
     f2=imdilate(f,ones(n_reconst_hor,ver));
     fd=imdilate(f2,ones(1,n_reconst_hor));
end

if(save_pictures)
    fd_image=[name,'_fd.tif'];
    imwrite(fd,fd_image);
end

f_obr=imreconstruct(imerode(fd,ones(1,n_erode_hor)),fd);

if(save_pictures)
    f_obr_image=[name,'_f_obr.tif'];
    imwrite(f_obr,f_obr_image);
end

g_obrd=imdilate(f_obr,ones(1,n_reconst_hor));

if(save_pictures)
    g_obrd_image=[name,'_g_obrd.tif'];
    imwrite(g_obrd,g_obrd_image);
end;

g_obrd2=imdilate(g_obrd,ones(n_reconst_ver,1));

if(save_pictures)
    g_obrd2_image=[name,'_g_obrd2.tif'];
    imwrite(g_obrd2,g_obrd2_image);
end;

f2=imreconstruct(min(g_obrd2,f),f);

if(save_pictures)
    f2_image=[name,'_f2.tif'];
    imwrite(f2,f2_image);
end

final=~f;

final_image=[name,'_final.tif'];
imwrite(final,final_image,'Resolution',[300 300]);


function [name, n_erode_hor, n_reconst_hor, n_reconst_ver,n_kind_fill, n_filterwindowsize ,gamma, save_pictures] = parseInputs(varargin)


iptchecknargin(1,8,nargin,mfilename);


name = varargin{1};
%n_erode_hor=10;
%n_reconst_hor=45;
%n_reconst_ver=1;
%n_kind_fill=2;
%n_filterwindowsize=10;
%gamma=15;


n_erode_hor=10;
if nargin > 1
  n_erode_hor = varargin{2};
  iptcheckinput(n_erode_hor, {'double'}, {}, mfilename, 'n_erode_hor', 2);

end

n_reconst_hor=45;
if nargin > 2
  n_reconst_hor = varargin{3};
  iptcheckinput(n_reconst_hor, {'double'}, {}, mfilename, 'n_reconst_hor', 3);

end

n_reconst_ver=5;
if nargin > 3
  n_reconst_ver = varargin{4};
  iptcheckinput(n_reconst_ver, {'double'}, {}, mfilename, 'n_reconst_ver', 4);

end

n_kind_fill=1;
if nargin > 4
  n_kind_fill = varargin{5};
  iptcheckinput(n_kind_fill, {'double'}, {}, mfilename, 'n_kind_fill', 5);

end

n_filterwindowsize=12;
if nargin > 5
  n_filterwindowsize = varargin{6};
  iptcheckinput(n_filterwindowsize, {'double'}, {}, mfilename, 'n_filterwindowsize', 6);

end

gamma=15;
if nargin > 6
  gamma = varargin{7};
  iptcheckinput(gamma, {'double'}, {}, mfilename, 'gamma', 7);

end

save_pictures=0;

if nargin > 7
  save_pictures = varargin{8};
  iptcheckinput(save_pictures, {'logical'}, {}, mfilename, 'save_pictures', 8);

end





%-------------------------------
function displayInternalError(string)

eid = sprintf('Images:%s:internalError',mfilename);
msg = sprintf('Internal error: %s is not valid.',upper(string));
error(eid,'%s',msg);






